#ifndef PAGEWRITER_H
#define PAGEWRITER_H

#include <stdio.h>
#include "logdef.h"
#include "logglobals.h"
#include "wire.h"
#include "node.h"

/* Local variables for savepage: */
struct LOC_savepage {
	log_hwrec *firsthwire;
	log_vwrec *firstvwire;
	log_nrec *firstnode;
	short numhw, maxunat;
};

short countnode(log_nrec *n, struct LOC_savepage *LINK);
short counthw(log_hwrec *hw, struct LOC_savepage *LINK);
short countvw(log_vwrec *vw, struct LOC_savepage *LINK);
int eqattr(log_kattrrec *ka, log_gattrrec *ga, struct LOC_savepage *LINK);
strlist_t *attrname(short i, strlist_t *lbl, struct LOC_savepage *LINK);
short countattrs(log_gattrrec *gattr, short numattrs, log_kattrrec *kattr, strlist_t *lbl, struct LOC_savepage *LINK);
void writeattrs(FILE **f, log_gattrrec *gattr, short numattrs, log_kattrrec *kattr, strlist_t *lbl, struct LOC_savepage *LINK);
void savepage(short pgnum, char *filename_);
void emergencysave(short pgnum);
void safesavepage(short pgnum, char *fn);

#endif
