#define SYSDEVS_G

#include <time.h>
#include <sys/time.h>
  
#include <utils/p2c.h>
#include <utils/sysglobals.h>
#include <utils/sysdevs.h>

long sysclock()
{
	struct timeval tv;
	gettimeofday(&tv, NULL);
	return tv.tv_sec % 86400 * 100 + tv.tv_usec / 10000;
}

void sysdate(daterec *thedate)
{
	struct tm *t;
	time_t temp = time(NULL);
	
	t = localtime(&temp);
	thedate->year = (char) t->tm_year % 100;
	thedate->day = t->tm_mday;
	thedate->month = t->tm_mon+1;
}

void systime(timerec *thetime)
{
	struct timeval tv;
	struct tm *t;
	time_t temp;

	gettimeofday(&tv, NULL);
	temp = tv.tv_sec;
	t = localtime(&temp);

	thetime->hour = t->tm_hour;
	thetime->minute = t->tm_min;
	thetime->centisecond = t->tm_sec * 100 + tv.tv_usec / 10000;
}
